{
                      A Darzs-modell szimulcija.
                   (Keretprogram V.1.0 -- a knnyebb)
  Programspecifikci:
    Input:
        paramterek - N darzs-szm
                      K az 1. dobozban lev darazsak szma (a tbbi a 2.-ban)
        tjkoztat file sorokra trdelve
        beavatkozs - billentykkel (nagy s kisbetk nem klnbznek)
                      'c' = csendes zemmd;      'n' = norml zemmd;
                      'l' = lpsenknti zemmd; 'v' = vge
    Output:
        karakteres kpernyn = tjkoztat lapozott szvege
        grafikus kpernyn   = esemnytr (a kt doboz a bennk lev
                               darazsakkal)
                               grafikonablakok:
                               1. Eloszls   (az 1. dobozban relatve
                                  hnyszor volt 0, 1, ... db darzs)
                               2. Iddiagram (az 1. dobozban lev darazsak
                                  szma a 0., az 1., ... idegysgben; ill.
                                  az utols valahny idegysgben)
}
Program Szimulacio;

{ -------------------------------------------------------------------------
        Szimulcis program. (A fizikai... szimulcihoz.)

        Keretprogram -- Megolds.
  ------------------------------------------------------------------------- }
  Uses
{$IFDEF FPC --FreePascal}
    Crt,WinCrt,Graph;
{$ELSE -- TurboPascal}
    Newdelay,Crt,Graph;
{$ENDIF}
  Const
      MaxDB    = 140;
      MaxDb2   =  12; {sqrt(MaxDb)}
  Type
      TKepModok  =(Grafikus,Szoveges);
      TUzemModok =(Normal,Lepesenkenti,Csendes,Vege);
      THisztAblak= Record
                     bfx, bfy, jax, jay : Word;
                     cim                : String[32];
                     adatok             : Array [0..MaxDB] of LongInt;
                     adatdb             : Word;
                     leptek             : Real;
                     szin               : Byte;
                   End;

  Const
      Fejlec = ' Szimulci '; FejHossz = Length(Fejlec);
      HelpSor= ' V/v: vge , L/l: lpsenknt , N/n: norml , C/c: csendes ';
      Path   = '';
  Var
      KepMod  : TKepModok;
      UzemMod : TUzemModok;
      Graf1,
      Graf2   : THisztAblak;
        {Szimulcis adatok: paramterek, reprezentci...}
      T       : LongInt;
      N, K    : Integer;
      Darazs  : Array [1..MaxDB] of Record
                                      doboz    :1..2;
                                      holX,holY: Word
                                    End;
      darazsMaxX,
      darazsMaxY,
      darazsMeret: Word;
      dobozTerkep: Array [1..2,1..MaxDb2,1..MaxDb2] of (Szabad,Foglalt);
  Const
{$IFDEF FPC --FreePascal}
      kepMeret=40000;
{$ELSE -- TurboPascal}
      kepMeret=4000;
{$ENDIF}
  Var
      darazsKep  : Array [1..kepMeret] of Byte;
      {Kpernymentshez.
       Csak globlisan lehet ekkora adatot
       trolni a STACK OVERFLOW hiba nlkl:}
{$IFDEF FPC --FreePascal}
      buf : Array [1..3000000] of byte;
{$ELSE -- TurboPascal}
      buf : Array [1..30000] of byte;
{$ENDIF}

    {Ablakok, grafikonok kezelse: -----------------------------------------}

  Procedure ABlakLetrehozas(Var Graf : THisztAblak;
                            Const bx,by,jx,jy:Word;
                            Const c:String; Const aDb:Word;
                            Const l:Real; Const sz:Byte);
    Var
        i : Integer;
  Begin
    With Graf do                               {VGA-krtyt felttelezve!}
    Begin
      cim:=c;
      bfx:=bx; bfy:=by; jax:=jx; jay:=jy;
      adatdb:=aDb;
      leptek:=l;
      For i:=0 to Maxdb do adatok[i]:=0;
      szin:=sz;
    End;
  End; {ABlakLetrehozas}

  Procedure AblakRajzolas(Const Graf : THisztAblak);
    Var
        cx,cy : Integer;
  Begin
    SetViewPort(0,0,GetMaxX,GetMaxY,ClipOn);
    With Graf do
    Begin
      SetFillStyle(SolidFill,szin);
      Rectangle(bfx,bfy,jax,jay);
      cx:=(jax-bfx) div 2+bfx; cy:=TextHeight(' ')+bfy;
      OutTextXY(cx,cy,cim);
    End;
  End; {AblakRajzolas}

  Procedure TeljesGrafikon(Const Graf : THisztAblak);
    {A Graf ablakba a hisztogram jrarajzolsa}
    Var i  : Integer;
        osz: Word;
  Begin
    With Graf do
    Begin
      osz:=((jax-bfx) div adatdb);
      SetFillStyle(EmptyFill,Black{brmi});
      Bar(bfx+2,bfy+TextHeight(' ')+10,jax-2,jay-2);
      SetFillStyle(SolidFill,szin);
      For i:=0 to adatdb-1 do
      Begin
        bar(bfx+osz*(i)+2,trunc(jay-adatok[i]*leptek),
            bfx+osz*(i+1)+1,jay);
      End;
    End;
  End; {TeljesGrafikon}

  Procedure EloszlasFv(Szam: Word; Var Graf:THisztAblak);
    {A Szam-adik hisztogram-oszlop eggyel nvekszik}
    Var
        osz : Word;
  Begin
    With Graf do
    Begin
      SetFillStyle(SolidFill,szin);
      Inc(Adatok[Szam]);
      If Adatok[Szam]*leptek<(jay-bfy-TextHeight(' ')-10) then
      Begin
        If UzemMod<>Csendes then
          {nem csendes zemmdban:}
        Begin
          osz:=((jax-bfx) div (N+1));
          bar(bfx+osz*(Szam)+2,Trunc(jay-adatok[Szam]*leptek),
              bfx+osz*(Szam+1)+1,jay);
        End
      End
         Else
      Begin
        leptek:=leptek/2;  TeljesGrafikon(Graf);
      End;
    End;
  End; {EloszlasFv}

  Procedure IdoDiagram(Szam: Word; Var Graf:THisztAblak);
    {Az IdoDiagram jobbra egy Szam magassg oszloppal bvl,
     vagy shifteldnek oszlopai eggyel balra, majd bvl}
    Var osz : Word;
        i   : Integer;
  Begin
    With Graf do
    Begin
      SetFillStyle(SolidFill,szin);
      osz:=((jax-bfx) div (Maxdb));
      If adatdb<=MaxDb then
      Begin
        {adat hozzvtel a vgn:}
        adatok[adatdb]:=Szam;
        If UzemMod<>Csendes then
        Begin
          Bar(bfx+osz*adatdb+2,Trunc(jay-Szam*leptek),
              bfx+osz*(adatdb+1)+1,jay);
        End;
        Inc(adatdb);
      End
        Else
      Begin
        {Shift-els balra:}
        for i:=1 to adatdb-1 do adatok[i-1]:=adatok[i];
        {adat hozzvtel utolsknt:}
        adatok[adatdb-1]:=Szam;
        If UzemMod<>Csendes then
        Begin
          GetImage(bfx+osz+2,Trunc(jay-N*leptek),
                   bfx+osz*(adatdb+1)+1,jay, buf);
          PutImage(bfx+2,Trunc(jay-N*leptek),buf,NormalPut);
          bar(bfx+osz*(adatdb-1)+2,Trunc(jay-Szam*leptek),
              bfx+osz*adatdb+1,jay);
        End
      End;
    End;
  End; {IdoDiagram}

  Procedure DarazsTorles(Const doboz,holX,holY: Word);
    Var
       kX: Word;
  Begin
    If UzemMod<>Csendes then
    Begin   {nem csendes zemmdban:}
      If doboz=1 then kX:=20
                 Else kX:=(GetMaxX div 2)+20;
      Bar(kX+darazsMeret*(holX-1),20+darazsMeret*(holY-1),
          kX+darazsMeret*holX-1,20+darazsMeret*holY-1);
    End;
  End; {DarazsTorles}

  Procedure DarazsRajzolas(Const doboz,holX,holY: Word);
    Var
       kX: Word;
  Begin
    If UzemMod<>Csendes then
    Begin   {nem csendes zemmdban:}
      If doboz=1 then kX:=20
                 Else kX:=(GetMaxX div 2)+20;
      PutImage(kX+darazsMeret*(holX-1),20+darazsMeret*(holY-1),
               darazsKep,NormalPut);
    End;
  End; {DarazsRajzolas}

  Procedure OsszesDarazs;
    Var
       i,j: Word;  RegiUzemMod: TUzemModok;
  Begin
    RegiUzemMod:=UzemMod;
    UzemMod:=Normal; {ideiglenesen belltva, a rajzols rdekben}
    For i:=1 to darazsMaxX do For j:=1 to darazsMaxY do
    Begin
      DarazsTorles(1,i,j); DarazsTorles(2,i,j)
    End;
    For i:=1 to N do
    Begin
      DarazsRajzolas(Darazs[i].doboz,Darazs[i].holX,Darazs[i].holY)
    End;
    UzemMod:=RegiUzemMod; {visszalltva}
  End; {OsszesDarazs}

    {----------------------------------------- Ablakok, grafikonok kezelse}

    {Karakteres kperny- s billenty-kezels: ----------------------------}

  Procedure BillentyureVar(Var c: Char);
    {* Billentyfigyels
     * Vrakozskijelzs
     * zemmdbellts}
  Begin
    If KepMod=Szoveges then
    Begin
      c:='-';
      Repeat
        Case c of
          '|': c:='/';
          '/': c:='-';
          '-': c:='\';
          '\': c:='|';
        End;
        Window(1,1,80,25); GotoXY(35,25); Write('Lapozhatunk?',c);
        Delay(100);
      Until Crt.KeyPressed;
      c:=Crt.ReadKey;
    End
      Else
    Begin
      If UzemMod=Lepesenkenti Then
      Begin
        c:=WinCrt.ReadKey;
        Case c of
          'n','N': UzemMod:=Normal;
          'l','L': UzemMod:=Lepesenkenti;
          'c','C': UzemMod:=Csendes;
          'v','V': UzemMod:=Vege;
        End
      End
        Else
      If WinCrt.KeyPressed then
      Begin
        c:=WinCrt.ReadKey;
        Case c of
          'n','N': UzemMod:=Normal;
          'l','L': UzemMod:=Lepesenkenti;
          'c','C': UzemMod:=Csendes;
          'v','V': UzemMod:=Vege;
        End
      End
    End
  End; {BillentyureVar}

  Procedure SzovegesLap;
    {Standard mret, keretes, cmes, karakteres-kperny}
    Var
       i : Integer;
  Begin
    If KepMod=Grafikus then RestoreCrtMode;
    KepMod:=Szoveges;
    Window(1,1,80,25); TextColor(White); TextBackGround(Black); ClrScr;
    For i:=2 to 79 do
    Begin
      GotoXY(i,1); Write(''); GotoXY(i,24); Write('');
    End;
    For i:=1 to 24 do
    Begin
      GotoXY(1,i); Write(''); GotoXY(80,i); Write('');
    End;
    HighVideo;
    GotoXY(40-(FejHossz div 2),1); Write(Fejlec);
    NormVideo;
    Window(3,3,78,23);
  End; {SzovegesLap}

  Procedure Tajekoztato;
    {Tjkoztat lapozott kirsa a kpernyre file-bl}
    Const
       TajekoztatoFile = 'Darazs.hlp';
    Var
       c  : Char;
       s  : Byte;
       sor: String[80];
       tf : Text;
  Begin
    KepMod:=Szoveges; SzovegesLap;
    {A tjkoztat szvege:}

    (*ide kell a kd*)

  End; {Tajekoztato}

    {----------------------------  Karakteres kperny- s billenty-kezels}

    {A lnyeghez tartoz eljrsok s fggvnyek: --------------------------}

  Procedure Inicializalas;
    {Paramterbeolvass
     Grafikon-parametrizls
     Esemnytr inicializlsa}

    {TP-rl FP-re trs miatt:}
    Function TP2FP_X(x:Integer):Integer;
    Begin
    {$IFDEF FPC --FreePascal}
      TP2FP_X:=Trunc(x*GetMaxX/640)
    {$ELSE --TurboPascal}
      TP2FP_X:=x
    {$ENDIF}
    End;

    Function TP2FP_Y(y:Integer):Integer;
    Begin
    {$IFDEF FPC --FreePascal}
      TP2FP_Y:=Trunc(y*GetMaxY/480)
    {$ELSE --TurboPascal}
      TP2FP_Y:=y
    {$ENDIF}
    End;

    Var
       i,j,
       holX,
       holY,
       n2   : Integer;
       gd,gm: SmallInt;
       dDb  : Byte;
       d    : Array [1..8] of Record x,y:Byte End;
  Begin {Inicializalas}

      {Paramterbeolvass: N, K rtke}
    SzovegesLap;

    (*ide kell a kd*)
    N:=100; K:=0;

      {Grafikon-parametrizls:}
    gd:=Detect; InitGraph(gd,gm,Path); ClearViewPort; {ideiglenes grafikus zemmd}
    AblakLetrehozas(Graf1,
                    TP2FP_X(10),TP2FP_Y(250),
                    TP2FP_X(310),TP2FP_Y(460),
                    'Eloszls',N+1,5,White);
    AblakLetrehozas(Graf2,
                    TP2FP_X(330),TP2FP_Y(250),
                    TP2FP_X(630),TP2FP_Y(460),
                    'Vltozs',0,TP2FP_Y(460-250-20)/N,White);

      {Esemnytr inicializlsa:}
      {darzskp-generls:}
      {N-hez kzeli, annl nem kisebb ngyzetszm keresse:}
    n2:=Trunc(Sqrt(N));
    While n2*n2<N do Inc(n2);
    darazsMaxX:=n2; darazsMaxY:=n2; darazsMeret:=(GetMaxY-30) div (2*n2);
    i:=ImageSize(0,0,darazsMeret-1,darazsMeret-1);
    If i>kepMeret then {Tl nagy mret darzskp kellene!!!!}
    Begin
      Writeln('Tl nagy mret darzskp kellene!!!! Megllunk.');
      WinCrt.ReadKey;
      Halt(1);
    End;
    {Darzskp-generls:}
    For i:=3 to darazsMeret-3 do
    Begin
      For j:=3 to darazsMeret-3 do
      Begin
        PutPixel(i,j,Random(16));
      End;
    End;
      {Darzskp mentse:}
    GetImage(0,0,darazsMeret-1,darazsMeret-1,darazsKep); ClearViewPort;
      {Darazsak elhelyezse a Darazs[1..N]-ban, DobozTerkep[,,]-ben:}

    (*ide kell a kd*){amg Darazs tmb "res", addig a megjelents tkletlen!!!}
    
    CloseGraph; {--------------- az ideiglenes grafikus zemmd lezrsa}
  End; {Inicializalas}

  Procedure KezdoKepernyo;
    {Grafikus kp inicializlsa:
       * CimAblak: cim kiirasa
       * IdAblak: T kirsa
       * HalpAblak: Help-sor kirsa
       * GrafikonAblakok: resen
       * EsemnyTrAblak: kezd llapotban}
    Var
       ct   : String;
       lct,
       cx,cy: Integer;
       gd,gm: SmallInt;
       gFejHossz: Integer;
  Begin
      {A grafikus kp inicializlsa:}
    KepMod:=Grafikus;
    gd:=Detect; InitGraph(gd,gm,Path); ClearViewPort;
    gFejHossz:=FejHossz*TextWidth(' ');
    SetTextJustify(CenterText,TopText);
    SetLineStyle(SolidLn,0,{NormWidth}ThickWidth);
    SetViewPort(0,0, GetMaxX,GetMaxY, ClipOn);
    Rectangle(6,6, GetMaxX-5,GetMaxY-5);
      {CimAblak: cim kiirasa:}
    cx:=GetMaxX div 2; cy:=TextHeight(' ') div 2;
    SetViewPort(cx-(gFejHossz div 2)-8,0,
                cx+(gFejHossz div 2)+7,2*cy+7, ClipOn);
    ClearViewPort;
    Rectangle(4,2, gFejHossz+9,2*cy+5);
    OutTextXY((gFejHossz+15){6} div 2,4,Fejlec);
      {IdAblak: T kiirsa:}
    ct:=' T:'; lct:=10*TextWidth(' ');
    SetViewPort(GetMaxX-lct-8,0, GetMaxX,2*cy+7, ClipOn);
    ClearViewPort;
    Rectangle(4,2, lct+9,2*cy+5);
    OutTextXY((lct+15) div 2,4,ct);
      {HelpAblak: Help-sor:}
    ct:=HelpSor; lct:=Length(ct)*TextWidth(' ');
    SetViewPort(cx-(lct div 2)-8,GetMaxY-TextHeight(' ')-6,
                cx+(lct div 2)+7,GetMaxY, ClipOn);
    ClearViewPort;
    Rectangle(2,2, lct+9,2*cy+5);
    OutTextXY((lct+15) div 2,4,ct);
      {GrafikonAblakok:}
    AblakRajzolas(Graf1);
    AblakRajzolas(Graf2);
    SetViewPort(0,0,GetMaxX,GetMaxY,ClipOn);
      {EsemnyTrAblak:}
    OsszesDarazs;

      {tovbbi ablakok:}

  End; {KezdoKepernyo}

  Procedure SzimulaciosLepes;
    {A lnyeg}
    Var i,
        honnan,hova,
        holX,holY  : Integer;
  Begin
       {A lnyeg innen hinyzik:}

    (*ide kell a kd*)

  End; {SzimulaciosLepes}

  Procedure EredmenyMegjelenites;
    Var
       ct  : String;
       lct : Integer;
  Begin
      {Idokiiras:}
    Str(t:5,ct); ct:=' T:'+ct; lct:=10*TextWidth(' ');
    SetViewPort(GetMaxX-lct-8,0, GetMaxX,TextHeight(' ')+7, ClipOn);
    ClearViewPort;
    Rectangle(2,2, lct+5,TextHeight(' ')+5);
    OutTextXY((lct+15) div 2,4,ct);
    SetViewPort(0,0,GetMaxX,GetMaxY,ClipOn);
      {Grafikonok:}
    EloszlasFv(K,Graf1);
    IdoDiagram(K,Graf2);
  End; {EredmenyMegjelenites}

  Function VegeE: Boolean;
    Var
       c : Char;  
       RegiUzemMod: TUzemModok;
  Begin
    RegiUzemMod:=UzemMod;
    BillentyureVar(c);  {esetleges zemmdvlts}
    If (RegiUzemMod=Csendes) And (c in ['n', 'N', 'l', 'L']) then
    Begin  {Grafikonfrissts:}
      TeljesGrafikon(Graf1);
      TeljesGrafikon(Graf2);
      OsszesDarazs;
    End;
    VegeE:=(UzemMod=Vege) {And (automatikus vgllapot rzkels)}
  End; {VegeE}

  Procedure OsszefoglaloMegjelenites;
    {Tjkoztat lapozott kirsa a kpernyre file-bl}
    Const
       TajekoztatoFile = 'Darazs.sum';{szimulci-sszefoglal}
    Var
       c  : Char;
       s  : Byte; {a kirand sor sorszma}
       sor,       {a kirand sor szvege}
       sE,sK,sV: String[80];
       tf : Text;
    Procedure
      Szetszed(Const sor,minel:String; Var sE,sV:String);
      { Ef: minel RSZE sor
	  * Uf: sE,sV RSZE sor  S
      *     sor=sE+minel+sV
      }
      Var
       i: Byte;
    Begin
      i:=Pos(minel,sor);
      sE:=Copy(sor,1,i-1); sV:=Copy(sor,i+Length(minel),255); {255=vgig}
    End; {Szetszed}
  Begin
      {Az sszefoglal elre elksztett szvege, 
      * beillesztend "konkrtumokkal":
      * <@T@> -- vgid
      * <@N@> -- ssz-darzs-szm
      * <@K@> -- pillanatnyi darzs-szm a baloldaliban
      * }
    SzovegesLap; CloseGraph;
    BillentyureVar(c);
    Assign(tf,TajekoztatoFile);
    {$i-}
    Reset(tf);
    {$i+}
    If IOResult=0 then
    Begin
      While not Eof(tf) do
      Begin
        SzovegesLap;
        s:=1;
        Repeat
          Readln(tf,sor);
          While Pos('<@T@>',sor)>0 do
          Begin
            Szetszed(sor,'<@T@>',sE,sV); 
            Str(T,sK);
            sor:=sE+sK+sV;
          End;
          While Pos('<@N@>',sor)>0 do
          Begin
            Szetszed(sor,'<@N@>',sE,sV); 
            Str(N,sK);
            sor:=sE+sK+sV;
          End;
          While Pos('<@K@>',sor)>0 do
          Begin
            Szetszed(sor,'<@K@>',sE,sV); 
            Str(K,sK);
            sor:=sE+sK+sV;
          End;
          Writeln(sor); Inc(s)
        Until Eof(tf) or (s=20);
        BillentyureVar(c);
      End; {While}
      Close(tf);
    End
       Else
    Begin
      HighVideo; Writeln('  Nincs meg az sszefoglal file!!!  '); NormVideo;
      BillentyureVar(c)
    End; {If IOResult}
    ClrScr; GotoXY(25,10); Writeln('Itt a vge fuss el vle!!!!');
  End; {OsszefoglaloMegjelenites}

    {-------------------------- A lnyeghez tartoz eljrsok s fggvnyek}

Begin
  UzemMod:=Lepesenkenti; KepMod:=Szoveges; 
  Tajekoztato;
  Inicializalas; T:=0;
  KezdoKepernyo;
  EredmenyMegjelenites;
  While not VegeE do
  Begin
    SzimulaciosLepes;
    Inc(T);
    EredmenyMegjelenites;
  End;
  (* az albbi nem megy afpc v6.6.4 verziban, a Graph unit hibja miatt:
  OsszefoglaloMegjelenites;
  *)
End.
